﻿using System.Linq;
using Sirenix.OdinInspector.Editor;
using UnityEditor;
using UnityEngine;

[OdinDrawer]
public class MyTypeDrawer : OdinValueDrawer<MyType>
{
	protected override void DrawPropertyLayout( IPropertyValueEntry<MyType> entry, GUIContent label )
	{
		EditorGUILayout.BeginHorizontal();

		var property = entry.Property;

		this.CallNextDrawer( entry, label );

		if ( GUILayout.Button( "⊙", GUILayout.Width( 24f ) ) )
		{
			var selector = new MyTypeOdinSelector();
			selector.SelectionConfirmed += ev =>
			{
				property.Tree.DelayAction( () =>
				{
					entry.SmartValue = ev.FirstOrDefault();
					entry.ApplyChanges();
				} );
			};
			selector.ShowInPopup();
		}

		EditorGUILayout.EndHorizontal();
	}
}