﻿using Sirenix.OdinInspector.Editor;
using UnityEngine;
using System.Linq;
using Sirenix.OdinInspector;
using UnityEditor;

public class MyTypeOdinSelector : OdinSelector<MyType>
{
	public MyTypeOdinSelector()
	{
		this.DrawConfirmSelectionButton = true;
	}

	protected override void BuildSelectionTree( OdinMenuTree tree )
	{
		tree.Config.DrawSearchToolbar = true;

		var assets = AssetDatabase.FindAssets( string.Format( "t:{0}", typeof( MyType ).FullName ) );

		foreach ( var assetGuid in assets )
		{
			var path = AssetDatabase.GUIDToAssetPath( assetGuid );
			var asset = AssetDatabase.LoadAssetAtPath<MyType>( path );
			tree.Add( asset.name, asset, AssetDatabase.GetCachedIcon( path ) );
		}
	}

	[OnInspectorGUI]
	private void DrawInfoAboutSelectedItem()
	{
		var selected = this.GetCurrentSelection().FirstOrDefault();

		if ( selected != null )
		{
			GUILayout.Label( string.Format( "Name: {0}", selected.name ) );
		}
	}
}